<%@ LANGUAGE = VBScript %>
<%
Option Explicit

'This ASP script originally lived at http://evolvedcode.net/ for the 
'original version of this script and a wide variety of other
'scripts, please visit the site.

'For the latest version of this code please see;
'  http://evolvedcode.net/content/code_smart404/

'Updated by Richard Light June 2008 to support "Semantic Web"-type 303 "See Other"
' redirects.  This involved adding simple "wild card" support: just a single
' * at the end of the source pattern and anywhere within the target pattern.

Sub Redirect_LoadRules( ByRef sRules )
'Code to load our hardcoded data into an array (size 3 changed to 4, rbl 9.6.2008)
ReDim sRules( 4, 0 )

'*** The following lines control your redirects & rules ***
'*** you will need to modify them to create the rules   ***
'*** for your own website.                              ***

'*** Begin actual rules ***

ReDirect_Add "/object/rdf/*", "rdf?class=object&target=4&level=3&application=Object&filename=WTcoll&indexname=Identity number&indexkey=*", "EXECUTE", "", sRules
ReDirect_Add "/object/xtm/*", "xtm?class=object&target=4&level=3&application=Object&filename=WTcoll&indexname=Identity number&indexkey=*", "EXECUTE", "", sRules
ReDirect_Add "/object/page/*", "http://collections.wordsworth.org.uk/wtweb/home.asp?page=Objects&objectname=*", "PERM", "", sRules
'ReDirect_Add "/object/*", "/resource.asp?class=object&app=Object&file=WTcoll&index=Identity number&key=*", "SEEALSO", "application/rdf+xml", sRules
'ReDirect_Add "/object/*", "http://collections.wordsworth.org.uk/wtweb/home.asp?page=Objects&objectname=*", "SEEALSO", "", sRules
ReDirect_Add "/object/*", "/object/rdf/*", "SEEALSO", "application/rdf+xml", sRules
ReDirect_Add "/object/*", "/object/rdf/*", "SEEALSO", "text/xml", sRules
ReDirect_Add "/object/*", "/object/rdf/*", "SEEALSO", "application/xml", sRules
ReDirect_Add "/object/*", "/object/xtm/*", "SEEALSO", "application/xtm+xml", sRules
ReDirect_Add "/object/*", "/object/page/*", "SEEALSO", "", sRules

'*** End actual rules ***

'*** Begin example rules ***

'If source was directory "/dirA1" then temporary redirect to "/dirA2/"
'ReDirect_Add "/dirA1", "/dirA2/", "TEMP", sRules
'If source page was "/dirB1/myoldpage.htm" then permanent redirect to "/dirB2/mynewpage.htm"
'ReDirect_Add "/dirB1/myoldpage.htm", "/dirB2/mynewpage.htm", "PERM", sRules
''If source page was "/dirC1/mydeletefile.htm" then respond with "permanently removed"
'ReDirect_Add "/dirC1/mydeletefile.htm", "", "GONE", sRules
'If source page was "/dirC1/mydeletefile.htm" then respond with "access denied"
'ReDirect_Add "/dirD1/mypassword.htm", "", "DENY", sRules
'If source page was "/dirE1/simplename.htm" then make it appear this page exists by running "/dirE2/longname.asp" instead
'ReDirect_Add "/dirE1/simplename.htm", "/dirE2/longname.asp", "VIRT", sRules

'*** End example rules ***
End Sub

Sub Redirect_Main()
'Code to run the core of the smart 404 handling
Dim sSrcPage, sDstPage, sOpType
Dim iStatus
Dim sVersion, iVersion

'Check our list of redirects to see if this error is a known error and so can be 
' gracefully handled, otherwise trip out a 404

sSrcPage = ReDirect_SourcePage
iStatus = 0

'Determine the the version number of the server software, this will then
' be used later on to enable us to check if it supports server.transfer
sVersion = Request.ServerVariables("SERVER_SOFTWARE")
sVersion = Right( sVersion, Len( sVersion ) - InStrRev( sVersion, "/" ) )
If IsNumeric( sVersion ) Then
	iVersion = CInt( sVersion )
End If

'Run custom hardcoded rewrites
'If ReDirect_ReWrite( sSrcPage ) Then
'	Response.End
'End If

'Run standard handler code
If sSrcPage <> vbNullString Then
	iStatus = Redirect_CheckRules( sSrcPage, sDstPage, sOpType )
Else
	sOpType = "404 File Not Found"
End If

'Check if we have set a return status code
If iStatus > 0 Then
	'Test if the output from the redirect code is numeric
	If ISNumeric( Left( sOpType, 3 ) ) Then
		'Compare the status code and the status text
		If CInt( Left( sOpType, 3 ) ) = CInt( iStatus ) Then
			'Assign the returned status text
			Response.Status = sOpType
		End If
	End If

	If iStatus = 200 Then
		Response.Status = sOpType
		'Response.Write("<p>Destination page:"+sDstPage+"<p/>")
		ExecuteResponse( sDstPage )
	End If
		
	If iStatus = 301 Or iStatus = 302 Then
		Response.AddHeader "Location", sDstPage
%><html>
<head>
  <title>Object moved</title>
  <meta name="robots" content="noindex" />
</head>
<body>
  <h1>Object moved</h1>
  The requested object can currently be found <a href="<%= sDstPage %>">here</a>.
</body>
</html>
<%
	ElseIf iStatus = 303 Then
		Response.AddHeader "Location", sDstPage
		Response.AddHeader "Connection", "close"
		Response.AddHeader "Accept-Ranges", "bytes"
		Response.AddHeader "Vary", "accept"
		If Response.ContentType <> vbNullString Then
			Response.ContentType = Response.ContentType + ";qs=1"
		End If
	ElseIf iStatus = 403 Then
%><html>
<head>
  <title>Access Denied</title>
  <meta name="robots" content="noindex nofollow" />
</head>
<body>
  <h1>Access Denied</h1>
  Access to the requested resource has been denied.
</body>
</html>
<%
	ElseIf iStatus = 1001 And iVersion >= 5 Then
		'Server.Transfer will not work with pages which include a 
		' querystring so strip it if there is one
		sDstPage = URL_StripQuerystring( sDstPage )
		Response.Write "Test :: " & sDstPage
		Response.End
		Server.Transfer( sDstPage )
	End If

	If iStatus <> 404 And iStatus <> 410 Then
		Response.End
	End If

Else
	'We were unable to match a handler to this
	' URL so fail through to a generic 404 as
	' we cant offer a better answer
	Response.Status = "404 Not Found"
	
	'Since this is now a real 404, is you wanted
	' to add any kind of logging, this is where
	' you'd need to do it
	'Redirect_LogEvent( sSrcPage )
End If

End Sub

Sub ExecuteResponse( ByVal URL )
'Executes the target URL directly
Dim operation
Dim queryOffset
	
	queryOffset = InStr( URL, "?" )
	operation = Left( URL, queryOffset - 1 )
	
	Select Case LCase( operation )
		case "rdf"
			GetRDF( Right( URL, Len( URL ) - queryOffset ) )
		case "xtm"
			GetXTM( Right( URL, Len( URL ) - queryOffset ) )
		Case Else
			Response.Write("<p>Unknown operation: "+operation+"</p>")
	End Select
	
End Sub

Function ExtractParameter( ByVal parm, ByVal args )
Dim parmOffset, sepOffset
Dim workS

	'ExtractParameter = parm
	parmOffset = InStr( 1, args, parm )
	If parmOffset > 0 Then
		workS = Right( args, Len( args ) - ( parmOffset + Len( parm ) ) )
		sepOffset = InStr( 1, workS, "&" )
		If sepOffset > 0 Then
			ExtractParameter = Left( workS, sepOffset - 1 )
		Else
			ExtractParameter = workS
		End If
	End If
	
End Function

Sub GetRDF( ByVal Arguments )
Dim xslt
Dim xsldoc
Dim docUrl

	Set xslt = CreateObject("Msxml2.XSLTemplate")
  Set xsldoc = CreateObject("Msxml2.FreeThreadedDOMDocument.3.0")
  docUrl = "http://wordfile01:9876/scripts/modescgi.exe/?"+Arguments

	Server.ScriptTimeout = 120
	Response.Expires = 0

  xsldoc.async = false
  xsldoc.setProperty "ServerHTTPRequest", true 
  xsldoc.load( Server.MapPath( "generateRTF.xsl" ))

	If xsldoc.parseError.errorCode = 0 Then
	Dim xmlDoc
	
	 	xslt.stylesheet = xsldoc
	 	Set xmlDoc = CreateObject("Msxml2.DOMDocument.3.0")
	 	xmlDoc.async = false
 	 	xmlDoc.setProperty "ServerHTTPRequest", true
	 	xmlDoc.load( docUrl )
	  If xmlDoc.parseError.errorCode = 0 Then
		Dim xslProc
		
			Set xslProc = xslt.createProcessor()
			xslProc.addParameter "class", ExtractParameter( "class", Arguments )
			xslProc.addParameter "identity", ExtractParameter( "indexkey", Arguments )
		 	Response.ContentType = "application/rdf+xml"
		 	xslProc.input = xmlDoc
		 	xslProc.output = Response
		 	xslProc.transform()
		End If

	End If
End Sub

Sub GetXTM( ByVal Arguments )
Dim xslt
Dim xsldoc
Dim docUrl

	Set xslt = CreateObject("Msxml2.XSLTemplate")
  Set xsldoc = CreateObject("Msxml2.FreeThreadedDOMDocument.3.0")
  docUrl = "http://wordfile01:9876/scripts/modescgi.exe/?"+Arguments

	Server.ScriptTimeout = 120
	Response.Expires = 0

  xsldoc.async = false
  xsldoc.setProperty "ServerHTTPRequest", true 
  xsldoc.load( Server.MapPath( "object-xtm2.xsl" ))

	If xsldoc.parseError.errorCode = 0 Then
	Dim xmlDoc
	
	 	xslt.stylesheet = xsldoc
	 	Set xmlDoc = CreateObject("Msxml2.DOMDocument.3.0")
	 	xmlDoc.async = false
 	 	xmlDoc.setProperty "ServerHTTPRequest", true
	 	xmlDoc.load( docUrl )
	  If xmlDoc.parseError.errorCode = 0 Then
		Dim xslProc
		
			Set xslProc = xslt.createProcessor()
			xslProc.addParameter "class", ExtractParameter( "class", Arguments )
			xslProc.addParameter "identity", ExtractParameter( "indexkey", Arguments )
		 	Response.ContentType = "application/xtm+xml"
		 	xslProc.input = xmlDoc
		 	xslProc.output = Response
		 	xslProc.transform()
		End If

	End If
End Sub

Function Redirect_CheckRules( ByVal sSrcURL, ByRef sDstURL, ByRef sRuleType )
'Code to test if a given URL matches any of our existing rules, if does
' then retrieve the destination URL and the type of rule/operation
Dim sTmpDst, sTmpRule

'Fail closed
Redirect_CheckRules = 0

'Search the rules for the present URL
If Redirect_GetRuleURL( sSrcURL, sTmpDst, sTmpRule, Request.ServerVariables("HTTP_ACCEPT") ) Then
	
	Select Case LCase( sTmpRule )
		Case "perm"
			'Permanent redirect
			sRuleType = "301 Moved Permanently"
			sDstURL = URL_MakeAbsolute( sTmpDst )
			Redirect_CheckRules = 301
		Case "temp"
			'Temporary redirect
			sRuleType = "302 Moved Temporarily"
			sDstURL = URL_MakeAbsolute( sTmpDst )
			Redirect_CheckRules = 302
		Case "seealso"
			'See also: Semantic Web redirect
			sRuleType = "303 See Other"
			sDstURL = URL_MakeAbsolute( sTmpDst )
			Redirect_CheckRules = 303
		Case "execute"
			'Deliver content directly
			sRuleType = "200 OK"
			sDstURL = sTmpDst 
			Redirect_CheckRules = 200
		Case "deny"
			'Access forbidden
			sRuleType = "403 Access Denied"
			Redirect_CheckRules = 403
		Case "gone"
			'Resource gone
			sRuleType = "410 Gone"
			Redirect_CheckRules = 410
		Case "virt"
			'Temporarily alias the requested file
			sRuleType = "Virtual Alias"
			sDstURL = URL_MakeAbsolute( sTmpDst )
			Redirect_CheckRules = 1001
		Case Else
			'Request type was unknown
			'Response.Write "Unknown rule type encountered (" & sRules( 1, 0 ) & ")"
			'Response.End
	End Select
    
End If

End Function

Function Redirect_SourcePage()
'Figure out which page triggered this page
Dim sPage

ReDirect_SourcePage = vbNullString

'Ensure this is an error message we are capable of handling
If Left( Request.QueryString, 4 ) = "404;" Then
	'handler.asp?404;http://www.mysite.com/mypage.ext
	sPage = URL_Decode( Request.QueryString )

	'Drop everything before the semi-colon
	sPage = Right( sPage, Len( sPage ) - InStr( 1, sPage, ";" ) )

	'Tidy whats left of the url
	sPage = URL_StripQuerystring( sPage )
	sPage = URL_StripDefaultDoc( sPage )
	sPage = URL_Decode( sPage )
		
	'Attempt to strip out the server name
	If InStr( Len( "http://" )+1, sPage, "/" ) > 0 Then
		sPage = Right( sPage, Len( sPage ) - (InStr( Len( "http://" )+1, sPage, "/" )-1) )
	End If
		
	'Attempt to drop trailing forward slash if present
	If Right( sPage, 1 ) = "/" And sPage <> "/" Then
		sPage = Left( sPage, Len( sPage ) - 1 )
	End If
		
	'Assuming anything is left then return the data
	If Len( sPage ) > 0 Then
		'ReDirect_SourcePage = LCase( sPage )
		ReDirect_SourcePage = sPage
	End If
ElseIf Request.QueryString( "aspxerrorpath" ) <> vbNullString Then
	'handler.asp?aspxerrorpath=/dirB1/myoldpage.aspx
	sPage = URL_Decode( Request.QueryString( "aspxerrorpath" ) )

	'Tidy whats left of the url
	sPage = URL_StripQuerystring( sPage )
	sPage = URL_StripDefaultDoc( sPage )
	sPage = URL_Decode( sPage )
		
	'Attempt to strip out the server name
	If InStr( Len( "http://" )+1, sPage, "/" ) > 0 Then
		sPage = Right( sPage, Len( sPage ) - (InStr( Len( "http://" )+1, sPage, "/" )-1) )
	End If
		
	'Attempt to drop trailing forward slash if present
	If Right( sPage, 1 ) = "/" And sPage <> "/" Then
		sPage = Left( sPage, Len( sPage ) - 1 )
	End If
		
	'Assuming anything is left then return the data
	If Len( sPage ) > 0 Then
		ReDirect_SourcePage = LCase( sPage )
	End If
ElseIf Request.QueryString <> vbNullString Then
	'Querystring data is present, but it's not being presented in a format 
	' our script can understand.  Now would be a GREAT point to bail out
	' with a debug note since this sort of error should only happen during initial
	' deployment, not once the system has gone into production / live.

%><html>
<head>
  <title>A problem has been detected - Smart 404</title>
  <meta name="robots" content="noindex follow" />
</head>
<body>
Unfortunately the Smart 404 script has encountered a problem - an unknown data
format has been passed to the script, therefore it was unable to handle the request.
<p></p>
The data passed to the script was:<br/>
<blockquote><%= Server.HTMLEncode( Request.QueryString ) %></blockquote>
<p></p>
If you operate the site experiencing this problem and require further help with this
issue please <a href="http://evolvedcode.net/">contact us</a> to discuss the problem.

</body>
</html>
<%
	Response.End

End If

End Function

Function Redirect_Rewrite( ByVal sSourcePage )
'Trigger function for inline rewrites if required

End Function

Function URL_MakeAbsolute( ByVal sURI )
'Code to append current server name to be standards compliant, but first check 
' that the URL is making use of an absolute path

Const csHttpPrefix = "http://"

'First of all remove the default document if they exist
sURI = URL_StripDefaultDoc( sURI )

'Try to make the url absolute if possible
If StrComp( Left( sURI, Len( csHttpPrefix ) ), csHttpPrefix, vbTextCompare ) <> 0 And Left( sURI, 1 ) = "/" Then
	'Check if we have the HOST variable to work from
	URL_MakeAbsolute = csHttpPrefix & Request.ServerVariables("HTTP_HOST") & sURI
Else
	URL_MakeAbsolute = sURI
End If

End Function

Function URL_StripDefaultDoc( ByVal sURI )
'Code to remove the first instance of a default document name from a given URL

sURI = Replace( sURI, "/default.asp", "/", 1, 1, vbTextCompare )
sURI = Replace( sURI, "/default.html", "/", 1, 1, vbTextCompare )
sURI = Replace( sURI, "/default.htm", "/", 1, 1, vbTextCompare )
sURI = Replace( sURI, "/index.asp", "/", 1, 1, vbTextCompare )
sURI = Replace( sURI, "/index.html", "/", 1, 1, vbTextCompare )
sURI = Replace( sURI, "/index.htm", "/", 1, 1, vbTextCompare )

URL_StripDefaultDoc = sURI

End Function

Function URL_StripQuerystring( ByVal sURI )
'Code to strip querystring parameters to enable matching to work properly

If InStrRev( sURI, "?" ) > 0 Then
	sURI = Left( sURI, InStrRev( sURI, "?" ) - 1 ) 
End If

URL_StripQuerystring = sURI

End Function

Function UrlMatchesPattern( ByVal sSrcURL, ByVal SourceRuleURL )
'Returns True iff sSrcUrl matches pattern in SourceRuleURL
Dim LiteralPart
Dim StarOffset

'Response.Write( "Matching "+sSrcURL+" to "+SourceRuleURL+" " )

StarOffset = InStr( 1, SourceRuleURL, "*", vbTextCompare )
If StarOffset > 0 Then 
	LiteralPart = Left( SourceRuleURL, (StarOffset - 1) )
	'Response.Write( "Literal part = "+LiteralPart )
	UrlMatchesPattern = ( InStr( 1, sSrcUrl, LiteralPart, vbTextCompare ) = 1 )
Else
 	UrlMatchesPattern = ( StrComp( sSrcURL, SourceRuleURL, vbTextCompare )  = 0 ) 
End If

End Function

Function UpdateUrl( ByVal sSrcURL, ByVal SourceRuleURL, ByVal TargetRuleURL )
'Routine to match "*" in the source pattern and replace the corresponding
' part of the target pattern
Dim WildCardString
Dim StarOffsetSource
Dim StarOffsetTarget

'Response.Write("URL: "+sSrcUrl+"; source: "+SourceRuleURL+"; target: "+TargetRuleURL+" " )

StarOffsetSource = InStr( 1, SourceRuleURL, "*", vbTextCompare )
StarOffsetTarget = InStr( 1, TargetRuleURL, "*", vbTextCompare )
If StarOffsetSource > 0 And StarOffsetTarget > 0 Then
	WildCardString = Right( sSrcUrl, ( Len( sSrcUrl ) - ( StarOffsetSource - 1 ) ) )
	UpdateUrl = Left( TargetRuleURL, ( StarOffsetTarget - 1 ) ) + WildCardString + Right( TargetRuleURL, ( Len( TargetRuleURL ) - StarOffsetTarget ) )
Else
	UpdateUrl = TargetRuleURL
End If

'Response.Write( "Updated URL: "+UpdateUrl )
End Function

Function URL_Decode( ByVal sURI )
'Code to replace encoded characters with their physical representations, this is really
' aimed at stopping over-active browsers from breaking the redirect.
Dim iChar

For iChar = 33 To 126
	sURI = Replace( sURI, "%" & Hex( iChar ), Chr( iChar ), 1, 5, vbTextCompare )
Next

URL_Decode = sURI

End Function

Sub Redirect_Add( ByVal sSrcURL, ByVal sDstURL, ByVal sRuleType, ByVal sAcceptType, ByRef sRules() )
'Code to append new rules onto the rule array

'Clean up the source URL to force into our
' preferred source URL format (ie no default document
' and no trailing slash)
sSrcURL = URL_StripDefaultDoc( sSrcURL )
If Right( sSrcURL, 1 ) = "/" Then
	sSrcURL = Left( sSrcURL, Len( sSrcURL ) - 1 )
End If

'If last element has been populated then append an
' extra element to hold this new rule
If sRules( 0, UBound( sRules, 2 ) ) <> vbNullString Then
	ReDim Preserve sRules( 4, UBound( sRules, 2 )+1 )
End If

'Populate the element with our rule
sRules( 0, UBound( sRules, 2 ) ) = UBound( sRules, 2 )
sRules( 1, UBound( sRules, 2 ) ) = Trim( sSrcURL )
sRules( 2, UBound( sRules, 2 ) ) = Trim( sDstURL )
sRules( 3, UBound( sRules, 2 ) ) = LCase(Trim( sRuleType ))
sRules( 4, UBound( sRules, 2 ) ) = Trim( sAcceptType )

End Sub

Function Redirect_GetRuleURL( ByRef sSrcURL, ByRef sDstURL, ByRef sRuleType, ByRef sAcceptType )
'Code to recover a single rule by source URL
Dim sRules(), iRule

Redirect_GetRuleURL = False

'Load the rule data
Redirect_LoadRules sRules

'Response.Write("Source URL: "+sSrcUrl+" ")
'Cycle through all the redirects
For iRule = LBound( sRules, 2 ) To UBound( sRules, 2 )

	'Response.Write("Rule "+sRules( 1, iRule )+"; ")
	'Check if the source url matches the source redirect url
	If Not( Redirect_GetRuleURL ) And UrlMatchesPattern( sSrcURL, sRules( 1, iRule ) ) And ( sRules( 4, iRule ) = vbNullString Or InStr( 1, sRules( 4, iRule ),  sAcceptType, vbTextCompare ) > 0 ) Then

		'Response.Write("Match found")
		If sRules( 4, iRule ) <> vbNullString Then
			Response.ContentType = sRules( 4, iRule )
		End If
		Select Case LCase( sRules( 3, iRule ) )
			Case "perm"
				'Permanent redirect
				sRuleType = LCase( sRules( 3, iRule ) )
				sDstURL = UpdateUrl( sSrcUrl, sRules( 1, iRule), sRules( 2, iRule ) )
				sSrcURL = sRules( 1, iRule )
				'If sRules( 4, iRule ) = vbNullString Then
				'	Response.ContentType = "application/rdf+xml"
				'End If
				Redirect_GetRuleURL = True
			Case "temp"
				'Temporary redirect
				sRuleType = LCase( sRules( 3, iRule ) )
				sDstURL = UpdateUrl( sSrcUrl, sRules( 1, iRule), sRules( 2, iRule ) )
				sSrcURL = sRules( 1, iRule )
				Redirect_GetRuleURL = True
			Case "seealso"
				'See also
				sRuleType = LCase( sRules( 3, iRule ) )
				sDstURL = UpdateUrl( sSrcUrl, sRules( 1, iRule), sRules( 2, iRule ) )
				sSrcURL = sRules( 1, iRule )
				Redirect_GetRuleURL = True
			Case "execute"
				'Return generated page directly
				sRuleType = LCase( sRules( 3, iRule ) )
				sDstURL = UpdateUrl( sSrcUrl, sRules( 1, iRule), sRules( 2, iRule ) )
				sSrcURL = sRules( 1, iRule )
				Redirect_GetRuleURL = True
			Case "deny"
				'Access forbidden
				sRuleType = LCase( sRules( 3, iRule ) )
				sSrcURL = sRules( 1, iRule )
				Redirect_GetRuleURL = True
			Case "gone"
				'Resource gone
				sRuleType = LCase( sRules( 3, iRule ) )
				sSrcURL = sRules( 1, iRule )
				Redirect_GetRuleURL = True
			Case "virt"
				'Temporarily alias the requested file
				sRuleType = LCase( sRules( 3, iRule ) )
				sSrcURL = sRules( 1, iRule )
				sDstURL = sRules( 2, iRule )
				Redirect_GetRuleURL = True
			Case Else
				'Treat this case as an error
				'Response.Write "Unknown rule type encountered (" & sRules( 2, iRule ) & ")"
				'Response.End
		End Select

	End If

Next


End Function

'Run the error handling code
ReDirect_Main

'Assign this request a 404 status code and display the rest of their text
%>
<html>
<head>
  <title>404 - Page Not Found</title>
  <link rel="stylesheet" type="text/css" href="custom404.css" />
  <meta name="robots" content="noindex follow" />
</head>
<body>

<h1>404 - Page Not Found</h1>
Sorry but the page you were looking for has not been found.  We tried our best to direct you
to a suitable place automatically but we did not find a suitable match...
<p>Accept value is <% Response.Write( Request.ServerVariables( "HTTP_ACCEPT" ) ) %></p>
<h3>What can you do now?</h3>
Well you could try <a href="JAVASCRIPT:window.history.back();">going back</a> to the last page
you visited and then browsing somewhere else, alternatively you could visit our <a href="/">front page</a>
and try browsing your way down from there - whatever you're looking for should be available either
directly from the front page or from one of the sections which are linked from the front page.

<h3>If all else fails...</h3>
If you think that the link you just followed really should work and you've tried quite hard to 
access it then drop us an e-mail explaining which link keeps bringing you to this page and where you 
found it.  Most of the time these sorts of problems are automatically registered somewhere and somebody
will be dealing with it, but on the off-chance that for some reason this process has failed if you 
drop us an e-mail somebody will look into it. 

</body>
</html>